<?php
/**
 * goal_model.php - Model goal
 *
 * @author $Author: wichai $
 * @version $Id: goal_model.php,v 1.13 2011/10/19 04:13:26 wichai Exp $
 * @copyright Copyright (c) 2009, Tiller Software Co., Ltd.
*/

class goal_model extends CI_Model {
	function __construct() {
		parent::__construct();
        $this->load->model('unit/unit_model');
        //osa_load_lang('general');
        //osa_load_lang('unit');
   }
	function get_goalall($creatorid, $enabledflag=FALSE, $filter=FALSE, $selectentry=FALSE) {
		if ( $creatorid !== FALSE && !osa_is_int_one($creatorid) ) {
			// if creatorid not boolean FALSE and integet greater than one then return FALSE
			return FALSE;
		}
		$table_goal = $this->db->dbprefix('goal');
		$table_entry_point = $this->db->dbprefix('entry_point');
		$table_user = $this->db->dbprefix('user');
		$table_team_members = $this->db->dbprefix('team_members');
		$sql  = "SELECT g.id, g.title, g.createdate,g.status,u.displayname,u.firstname,u.middlename,u.lastname,e.id entryid,e.type" .
				  " from {$table_goal} g " .
		        " LEFT JOIN {$table_entry_point} e ON e.goalid=g.id " .
				  " LEFT JOIN {$table_user} u ON g.creatorid=u.id " .
				  " LEFT JOIN {$table_team_members} t ON t.goalid=g.id ";

	   $where = '';
	   $and_operator = '';
		if ($creatorid != FALSE){
			 $where = "(g.creatorid={$creatorid} OR t.userid={$creatorid}) ";
			 $and_operator = 'AND';
	   }
	   if ( $enabledflag !== FALSE  ){
		   if ( $enabledflag != CMS_GOAL_STATUS_ALL ) {
		   	 $where .= " $and_operator g.status={$enabledflag}";
		   }
		   else {
		   	// Show all shouldn't display deleted goals
		   	$where .= " $and_operator g.status!=". CMS_GOAL_STATUS_DELETE;
		   }
		   $and_operator = 'AND';
	   }
		if ($selectentry != FALSE){
	   	 $where .= " $and_operator e.type={$selectentry}";
	   	 $and_operator = 'AND';
	   }

		if ($filter != FALSE) {
	    	$filter = trim($filter);
	    	// filter LIKE conditions so that LIKE wildcards ('%', '_') in the string are escaped (add backslash).
	    	$filter = $this->db->escape_like_str($filter);
	    	// Split search to array by using delimeter ' ' (space)
			$filter = explode(' ', $filter);
			$or_operator = '';
			$search_sql = '';
			foreach ( $filter as $key => $val ) {
				// ignore empty value
				if ( !empty($val) ){
					// search title or creator columns
					$search_sql .= "{$or_operator} g.title LIKE '%$val%' OR u.displayname LIKE '%$val%' OR u.firstname LIKE '%$val%'
					OR u.middlename LIKE '%$val%' OR u.lastname LIKE '%$val%'";
				}
				$or_operator = " OR";
			}
			if ( !empty($search_sql) ){
				$where.= " $and_operator ({$search_sql})";
		}
		} // END OF $filter condition

		$sql .= " where $where GROUP BY g.id ORDER BY g.title";
	   $res = $this->db->query($sql);
		if ( $res->num_rows() <= 0 ){
			return FALSE;
		}
	   return $res->result();
	}
	function get_mygoal($creatorid, $type) {
		$table_goal = $this->db->dbprefix('goal');
		$table_entry_point = $this->db->dbprefix('entry_point');
		$table_linkunit = $this->db->dbprefix('linkunit');
		$table_resource = $this->db->dbprefix('resource');
		$sql_goal = "SELECT g.id,g.title ,e.type,lu.extid goalunit,r.unitid" .
						" FROM $table_goal g " .
						" LEFT JOIN $table_entry_point e ON e.goalid=g.id " .
						" LEFT JOIN $table_linkunit lu ON lu.extid=g.id " .
						" LEFT JOIN $table_resource r ON r.unitid=g.id and r.type in ($type) " .
		//$sql_goal .= " LEFT JOIN $table_resource r ON r.unitid=e.id and r.courseid=e.type and r.type in ($type) ";
						" WHERE g.creatorid =". $creatorid .
		//$sql_goal .= " and e.type <> 0 "; //fix null object
						" AND g.status=". CMS_GOAL_STATUS_ENABLE;

		$groupby = " GROUP BY id" ;
		$orderby = " ORDER BY g.title" ;
		$resobj = $this->db->query($sql_goal.$groupby.$orderby );
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		return $resobj->result();
	}
	function get_creator($goalid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('u.id,u.displayname,u.firstname,u.middlename,u.lastname');
	   $this->db->from('goal g');
	   $this->db->join('user u', 'g.creatorid=u.id');
	   $this->db->where('g.id',$goalid);
	   $this->db->order_by('u.displayname');
		$res = $this->db->get();
		if ( $res->num_rows()<= 0 )
			return FALSE;
		return $res->result();
	}
	function get_team($goalid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('u.id,u.displayname,u.firstname,u.middlename,u.lastname,tm.iseditor');
	   $this->db->from('team_members tm');
	   $this->db->join('user u', 'tm.userid=u.id');
	   $this->db->where('tm.goalid',$goalid);
	   $this->db->order_by('u.displayname');
		$res = $this->db->get();
		if ( $res->num_rows()<= 0 )
			return FALSE;
		return $res->result();
	}
	function get_goal($goalid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('g.*');
		$this->db->from('goal g');
		$this->db->where('g.id',$goalid);
		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}
	function get_entry_bygoal($goalid) {
		$this->db->select('g.id goalid, g.title ,  e.type, e.id entryid');
	   $this->db->from('goal g');
		$this->db->join('entry_point e', 'e.goalid=g.id', 'left');
		//->db->where('e.type',$type);
		$this->db->where('g.id',$goalid);
		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}

	function get_goalbyentryid($type,$goalid) {
		$this->db->select('g.*, e.type, e.id entryid');
	   $this->db->from('goal g');
		$this->db->join('entry_point e', 'e.goalid=g.id', 'left');
		$this->db->where('e.type',$type);
		$this->db->where('e.goalid',$goalid);
		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];

	}
	function get_goalbyuserid($userid) {
		$this->db->select('*');
	   $this->db->from('goal');
		$this->db->where('creatorid',$userid);
		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];

	}
	function add_goal($goal=FALSE,$entry=FALSE) {
		$id = FALSE;
		$this->db->trans_begin();
		if ($goal != FALSE) {
			$this->db->insert('goal', $goal);
			$id = osa_db_lastinsertid($this->db);
			if ( !$id ) {
				$this->db->trans_rollback();
				return FALSE;
			}
		}
		if ($entry != FALSE) {
			if (isset($entry->goalid) == FALSE)
				$entry->goalid = $id;
			$this->db->insert('entry_point', $entry);
			$id = osa_db_lastinsertid($this->db);
			if ( !$id ) {
				$this->db->trans_rollback();
				return FALSE;
			}
		}
		$this->db->trans_commit();
		return $id;
	}
	function edit_goal($goalid,$data) {
		$this->db->where('id',$goalid);
		$this->db->update('goal', $data);
		return TRUE;
	}
	function edit_entry_point($entryid,$data) {
		$this->db->where('id',$entryid);
		$this->db->update('entry_point', $data);
		return TRUE;

	}

	function get_goalbytpyeid($tpyeid) {
		$this->db->select('g.*, e.type, e.id entryid,e.completedate');
	    $this->db->from('goal g');
		$this->db->join('entry_point e', 'e.goalid=g.id', 'left');
		$this->db->where('e.id',$tpyeid);

		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}
	// fucnion team member dialog
	function get_team_member($goalid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('u.id,u.displayname,u.firstname,u.middlename,u.lastname,tm.iseditor');
	   $this->db->from('team_members tm');
	   $this->db->join('user u', 'tm.userid=u.id', 'left');
	   $this->db->where('tm.goalid',$goalid);
	   $this->db->order_by('u.displayname');
		$res = $this->db->get();
		if ( $res->num_rows()<= 0 )
			return FALSE;
		return $res->result();
	}
	function delete_team_member($goalid, $userid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		if ( !is_numeric($userid) )
			return FALSE;

		$this->db->query("DELETE FROM team_members where goalid = $goalid and userid = $userid ");
		return TRUE;
	}
	function insert_team_member($sql_data) {
		$team_members = $this->db->dbprefix('team_members');
		$sql = "INSERT INTO $team_members (userid,goalid) VALUES ";
		$this->db->query($sql . $sql_data );
		return TRUE;
	}
	function update_team_member($goalid,$userid,$data) {
		$this->db->where('goalid',$goalid);
		$this->db->where_in('userid',$userid);
		$this->db->update('team_members', $data);
		return TRUE;
	}
	function update_editor_member($goalid,$userid,$data) {
		$this->db->where('goalid',$goalid);
		$this->db->where('userid',$userid);
		$this->db->update('team_members', $data);
		return TRUE;
	}

	function get_goal_creator($goalid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('u.id,displayname');
		$this->db->from('user u');
		$this->db->join('team_members tm', 'tm.userid=u.id', 'left');
		$this->db->where('tm.goalid',$goalid);
		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}

	function get_goal_user_type($goalid,$userid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		if ( !is_numeric($userid) )
			return FALSE;
		$this->db->select('iseditor');
		$this->db->from('team_members');
		$this->db->where('goalid',$goalid);
		$this->db->where('userid',$userid);
		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}
	function insert_creator($data) {
		$this->db->insert('team_members', $data);
		return TRUE;
	}

	function get_entrypoint($entryid) {
		$this->db->select('*');
		$this->db->from('entry_point e');
		$this->db->where('e.id',$entryid);

		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}
	// end unit dialog
	function del_upload($table,$resourceid) {
	   $this->db->where_in('resourceid',$resourceid);
		$this->db->delete($table);
		return TRUE;
	}
  	function del_resource($table,$resourceid) {
	   $this->db->where_in('id',$resourceid);
		$this->db->delete($table);
		return TRUE;
	}
	function del_team_members($table,$goalid) {
	   $this->db->where('goalid',$goalid);
		$this->db->delete($table);
		return TRUE;
	}
	function del_entry_goal($table,$goalid) {
	   $this->db->where('goalid',$goalid);
		$this->db->delete($table);
		return TRUE;
	}
	function del_goal($table,$goalid) {
	   $this->db->where('id',$goalid);
		$this->db->delete($table);
		return TRUE;
	}
	function get_entry_pointbygoalid($goalid,$type) {
		$table_goal = $this->db->dbprefix('goal');
		$table_entry_point = $this->db->dbprefix('entry_point');
		$table_resource = $this->db->dbprefix('resource');

		$sql = "Select g.*, r.type, e.id entryid,r.id resid ";
		$sql .= " From $table_goal g ";
		$sql .= " LEFT JOIN $table_entry_point e ON e.goalid=g.id ";
		$sql .= " LEFT JOIN $table_resource r ON r.unitid=g.id and r.type in ($type)";
		//$sql .= " LEFT JOIN $table_resource r ON r.unitid=e.id and r.courseid=e.type and r.type in ($type)";

		$where = " Where g.id = ".$goalid;
		$resobj = $this->db->query($sql . $where );
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		return $resobj->result();
	}

	function check_goal_creator($goalid, $userid) {
		if ( !is_numeric($goalid) || !is_numeric($userid) )
			return FALSE;

		$table_goal = $this->db->dbprefix('goal');;
		$sql_goal = 'select creatorid userid, id goalid, '.CMS_GOAL_USER_EDITOR.' iseditor ';
		$sql_goal .= "from  $table_goal ";
		if ($goalid != FALSE)
			 $sql_goal .= "where id = ".$goalid;
		if ($userid != FALSE)
			 $sql_goal .= " and creatorid = ".$userid;
		$res = $this->db->query($sql_goal);
		if ( $res->num_rows() <= 0 )
			return FALSE;
		$rows = $res->result();
		return $rows[0];
	}

	function check_goal_editor($goalid, $userid) {
		if ( !is_numeric($userid) )
			return FALSE;

		$table_goal = $this->db->dbprefix('goal');;
		$sql_goal = 'select creatorid userid, id goalid, '.CMS_GOAL_USER_EDITOR.' iseditor ';
		$sql_goal .= "from  $table_goal ";
		if ($userid != FALSE)
			 $sql_goal .= "where creatorid = ".$userid;

		$table_member = $this->db->dbprefix('team_members');
		$sql_member = 'select userid, goalid, iseditor ';
		$sql_member .= "from  $table_member ";
		$sql_member .= "where iseditor = ".CMS_GOAL_USER_EDITOR;
		if ($userid != FALSE)
			 $sql_member .= " and userid = ".$userid;

		$sql  = 'select * from (' . $sql_goal .' union ' . $sql_member . ') m ';
		if ($goalid != FALSE)
		$sql .= 'where m.goalid = ' . $goalid;

		$res = $this->db->query($sql);
		if ( $res->num_rows() <= 0 )
			return FALSE;
		$rows = $res->result();
		return $rows[0];
	}
	function get_goal_write($goalid,$userid) {
			if ( !is_numeric($goalid) || !is_numeric($userid) )
			return FALSE;

		$table_goal = $this->db->dbprefix('goal');;
		$sql_goal = 'select creatorid userid, id goalid, '.CMS_GOAL_USER_EDITOR.' iseditor ';
		$sql_goal .= "from  $table_goal ";
		if ($userid != FALSE)
			 $sql_goal .= "where creatorid = ".$userid;

		$table_member = $this->db->dbprefix('team_members');
		$sql_member = 'select userid, goalid, iseditor ';
		$sql_member .= "from  $table_member ";
		if ($userid != FALSE)
			 $sql_member .= " where userid = ".$userid;

		$sql  = 'select * from (' . $sql_goal .' union ' . $sql_member . ') m ';
		if ($goalid != FALSE)
		$sql .= 'where m.goalid = ' . $goalid;

		$res = $this->db->query($sql);
		if ( $res->num_rows() <= 0 )
			return FALSE;
		$rows = $res->result();
		return $rows[0];
	}
	function get_goal_editor($goalid,$userid) {
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('tm.iseditor,u.id,u.displayname');
	   $this->db->from('team_members tm');
	   $this->db->join('user u', 'tm.userid=u.id', 'left');
	   $this->db->where('tm.goalid',$goalid);
	    $this->db->where('u.id',$userid);
		$res = $this->db->get();
		if ( $res->num_rows()<= 0 )
			return FALSE;
		$rows = $res->result();
		return $rows[0];
	}

	function get_goaltopdf($goalid,$type=FALSE) {
		$table_goal = $this->db->dbprefix('goal');
		$table_entry_point = $this->db->dbprefix('entry_point');
		$table_linkunit = $this->db->dbprefix('linkunit');
		$table_resource = $this->db->dbprefix('resource');
		$sql_goal = "Select e.id entry_id , e.type, g.id";
		$sql_goal .= " From $table_goal g ";
		$sql_goal .= " LEFT JOIN $table_entry_point e ON e.goalid=g.id ";
		$sql_goal .= " JOIN $table_linkunit lu ON lu.extid=g.id ";
		if ($goalid != FALSE)
			$sql_goal .= " Where lu.extid=".$goalid;

		$sql_resource = "Select e.id entry_id , e.type, g.id";
		$sql_resource .= " From $table_goal g ";
		$sql_resource .= " LEFT JOIN $table_entry_point e ON e.goalid=g.id ";
		$sql_resource .= " JOIN $table_resource r ON r.unitid=g.id and r.type in ($type) ";
		//$sql_resource .= " JOIN $table_resource r ON r.unitid=e.id and r.courseid=e.type and r.type in ($type) ";
		if ($goalid != FALSE)
			$sql_resource .= " Where r.unitid=".$goalid;

		$sql  = 'select * from (' . $sql_goal .' union ' . $sql_resource . ') m ';
		$sql .= ' where m.id = ' . $goalid;

		$groupby = " Group by entry_id" ;
		$orderby = " Order by type" ;
		$resobj = $this->db->query($sql.$groupby.$orderby );
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		return $resobj->result();
	}
	function get_entry($goalid, $entryid=FALSE){
		if ( !is_numeric($goalid) )
			return FALSE;
		$this->db->select('e.id entryid, e.type, e.completedate, e.goalid');
	   $this->db->from('entry_point e');
		$this->db->where('e.goalid',$goalid);
		if ($entryid != FALSE)
			 $this->db->where('e.id',$entryid);

		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			  return FALSE;
		if ( is_numeric($entryid)) {
			  $rows = $resobj->result();
			  return $rows[0];
		}
		else {
			  return $resobj->result();
		}
	}
	function get_user($notin_ids=FALSE) {
		$this->db->select('id, displayname');
		$this->db->from('user');
		//$enabled='1';
		$this->db->where('enabled',CMS_ADMIN_ENABLE);
		if ($notin_ids != FALSE && isset($notin_ids)!=FALSE && is_array($notin_ids))
			$this->db->where_not_in('id', $notin_ids);
		$this->db->where_not_in('username', array($this->config->item('cms_admin_username'),$this->config->item('cms_guest_username')));

		$this->db->order_by('displayname');
		$res = $this->db->get();
		if ( $res->num_rows() <= 0 )
			return FALSE;

		$user = $res->result();
		$result = array();
		foreach($user as $value) {
			$result[$value->id] = $value->displayname;
		}
		return $result;
	}
	function get_goal_byentryid($entryid) {
		$this->db->select('g.*, e.type, e.id entryid, e.completedate');
	    $this->db->from('goal g');
		$this->db->join('entry_point e', 'e.goalid=g.id', 'left');
		$this->db->where('e.id',$entryid);

		$resobj = $this->db->get();
	   if ( $resobj->num_rows() <= 0 )
			return FALSE;
		$rows = $resobj->result();
		return $rows[0];
	}
	function is_edit_goal($goalid) {
		$this->load->library('cms/cms_cache');
		$cache_key = $goalid;
		if ( ($cache_val = $this->cms_cache->db_get(__METHOD__, $cache_key) ) !== NULL )
			return $cache_val;

		$user = $this->login_model->getLogin();
		if ( !is_numeric($goalid) || !$user ) {
			$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
			return FALSE;
		}

		$this->load->model('auth/access_model');
		if ( $this->access_model->checkaccess_any('admin_goal_write', $user, FALSE, FALSE) || $this->is_goal_admin() ||
			  $this->is_goal_creator($goalid) || $this->is_goal_leader()) {
			$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
			return TRUE;
		}

		//Goal members can edit too
		if ($this->config->item('cms_goal_member_edit_support')){
			if ($this->is_goal_editor($goalid)) {
				$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
				return TRUE;
			}
		}
		$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
		return FALSE;
	}
	function is_goal_admin() {
		//$this->load->library('cms/cms_cache');
		if ( $this->access_model->checkaccess_any_noexit('admin_goal_write') ) {
			return TRUE;
		}
		if ( ($user = $this->login_model->getLogin()) == FALSE ) {
   		return FALSE;
    	}
		$cache_key = $user->id;
		if ( ($cache_val = $this->cms_cache->db_get(__METHOD__, $cache_key) ) !== NULL )
			return $cache_val;

		$table_user_role = $this->db->dbprefix('user_role');;

    	//TODO: Should make this into one query instead of 2
   	$this->db->where('userid', $user->id);
   	//$this->db->where_or('type', CMS_GOAL_ADMIN_USER_TYPE);
   	$admintype = CMS_GOAL_ADMIN_USER_TYPE;
   	$admingroup = CMS_USERROLE_GROUP_GOAL;
   	$where = "(type='$admintype' OR grouping='$admingroup')";
   	$this->db->where($where);
   	$res = $this->db->get($table_user_role);
   	if ( $res->num_rows() > 0 ) {
   		$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
    		return TRUE;
   	}
   	/*
		$this->db->where('userid', $user->id);
   	$this->db->where('grouping', CMS_USERROLE_GROUP_GOAL);
   	$res = $this->db->get($table_user_role);
   	if ( $res->num_rows() > 0 ) {
   		$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
    		return TRUE;
   	} */

   	$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
    	return FALSE;
   }

	function is_goal_creator($goalid) {
		$this->load->library('cms/cms_cache');
		$cache_key = $goalid;
		if ( ($cache_val = $this->cms_cache->db_get(__METHOD__, $cache_key) ) !== NULL )
			return $cache_val;

		if ( !is_numeric($goalid) ) {
			$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
			return FALSE;
		}
		$table_goal = $this->db->dbprefix('goal');
    	if ( ($user = $this->login_model->getLogin()) == FALSE ) {
    		$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
   		return FALSE;
    	}
   	$this->db->where('id', $goalid);
   	$this->db->where('creatorid', $user->id);
   	$res = $this->db->get($table_goal);
   	if ( $res->num_rows() <= 0 ) {
   		$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
    		return FALSE;
   	}
   	$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
    	return TRUE;
	}

	private function is_goal_editor($goalid) {
		if ( !is_numeric($goalid) ) {
			return FALSE;
		}
		$table_team_members = $this->db->dbprefix('team_members');
    	if ( ($user = $this->login_model->getLogin()) == FALSE ) {
   		return FALSE;
    	}
		$this->load->library('cms/cms_cache');
		$cache_key = $goalid;
		if ( ($cache_val = $this->cms_cache->db_get(__METHOD__, $cache_key) ) !== NULL ) {
			return $cache_val;
		}

   	$this->db->select('*');
		$this->db->from($table_team_members);
   	$this->db->where('goalid', $goalid);
   	$this->db->where('userid', $user->id);
   	$resobj = $this->db->get();
   	if ( $resobj->num_rows() <= 0 ) {
   		$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
    		return FALSE;
   	}
    	$row = $resobj->result();
    	$team_members = $row[0];
    	if (isset($team_members) && $team_members != FALSE && $team_members->iseditor != FALSE) {
    		$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
			return TRUE;
    	}
    	$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
    	return FALSE;
	}

	function is_goal_member($goalid) {
		$this->load->library('cms/cms_cache');
		$cache_key = $goalid;
		if ( ($cache_val = $this->cms_cache->db_get(__METHOD__, $cache_key) ) !== NULL )
			return $cache_val;

		if ( !is_numeric($goalid) ) {
			$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
			return FALSE;
		}
		$table_team_members = $this->db->dbprefix('team_members');
    	if ( ($user = $this->login_model->getLogin()) == FALSE ) {
    		$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
   		return FALSE;
    	}
   	$this->db->select('*');
		$this->db->from($table_team_members);
   	$this->db->where('goalid', $goalid);
   	$this->db->where('userid', $user->id);
   	$resobj = $this->db->get();
   	if ( $resobj->num_rows() <= 0 ) {
   		$this->cms_cache->db_add(__METHOD__, $cache_key, FALSE);
    		return FALSE;
   	}
		$this->cms_cache->db_add(__METHOD__, $cache_key, TRUE);
		return TRUE;
	}
	//Update table column deleted in a goal
	function update_deleted($goalid,$data) {
		$table_goal = $this->db->dbprefix('goal');;
		$this->db->where('id',$goalid);
		$this->db->update($table_goal, $data);
		return TRUE;
	}

	//CHeck to see does a goal has a survey or not
	function has_survey($goalid) {
		$this->db->select('surveyid');
		$this->db->from('survey_goal');
		$this->db->where('goalid', $goalid);
		$resobj = $this->db->get();
		if ( $resobj->num_rows() <= 0 ) {
			return FALSE;
		}
		return TRUE;
	}

	//Check for goal leaders like GLL and CAL
	function is_goal_leader() {
		static $handlemodel_loaded = FALSE;
		if ( !$handlemodel_loaded ) {
			$this->load->model('unit/event/handle_user_role_model');
			$handlemodel_loaded = TRUE;
		}
		if (!($user = osa_login_object())) {
			return FALSE;
		}
		return $this->handle_user_role_model->is_grouping($user->id, CMS_USERROLE_GROUP_GOAL_NONADMIN);
	}
	
	function has_goal_by_surveyid($surveyid){
		if ( !osa_is_int($surveyid) ){
			return FALSE;
		}
		$this->db->select('goalid');
		$this->db->from('survey_goal');
		$this->db->where('surveyid', $surveyid);
		$resobj = $this->db->get();
		if ( $resobj->num_rows() <= 0 ) {
			return FALSE;
		}
		return TRUE;
	}

	function archive_all(){
		$goal_data = new stdClass();
		$goal_data->status = CMS_GOAL_STATUS_ARCHIVE;
		$goal_data->modifydate = osa_dbdate();
		$this->db->where('status', CMS_GOAL_STATUS_ENABLE);
		return $this->db->update('goal', $goal_data);
	}

	function get_goalstatus_by_surveyid($surveyid){
		if ( !osa_is_int($surveyid) ){
			return FALSE;
		}
		$this->db->select('g.status');
		$this->db->from('goal g');
		$this->db->join('survey_goal sg', 'sg.goalid=g.id');
		$this->db->where('sg.surveyid', $surveyid);
		$res = $this->db->get();
		if ( $res->num_rows() <= 0 ){
			return FALSE;
		}
		$result = $res->result();
		return $result[0];
	}

	function get_numrows_enabled(){
		$this->db->select('*');
		$this->db->from('goal');
		$this->db->where('status', CMS_GOAL_STATUS_ENABLE);
		$res = $this->db->get();
		$numberofrows = $res->num_rows();
		if ( $numberofrows <= 0 ){
			return FALSE;
		}
		return $numberofrows;
	}

	function get_active_users() {
		// select firstname, middlename, lastname and displayname to get name in osa_user_getname
		$this->db->select('u.id, u.firstname, u.middlename, u.lastname, u.displayname');
		$this->db->from('user u');
		$this->db->join('goal g', 'g.creatorid=u.id');
		$this->db->where('enabled', CMS_DB_BOOLEAN_TRUE);
		$this->db->group_by('u.id');
		$res = $this->db->get();
		if ( $res->num_rows() <= 0 ){
			return FALSE;
		}
		$users = $res->result();
		$result_array = array();
		// Make top dropdown list. get_goalall() ignore creatorid when it false/zero
		$top_dropdown[0] = lang('goal_creator_toplist');
		foreach($users as $value) {
			$result_array[$value->id] = osa_user_getname($value);
		}
		// use natural order function from php instead of sql function
		natsort($result_array);
		// can't use array_merge because we need array index so use plus to union arrays
		$result_with_topdropdown = $top_dropdown + $result_array;
		return $result_with_topdropdown;
	}

	function is_goal_enabled($goalid){
		return $this->_check_goal_status(CMS_GOAL_STATUS_ENABLE, $goalid);
	}

	function is_goal_enabled_by_surveyid($surveyid){
		return $this->_check_goal_status(CMS_GOAL_STATUS_ENABLE, FALSE, $surveyid);
	}

	function is_goal_disabled($goalid){
		return $this->_check_goal_status(CMS_GOAL_STATUS_DISABLE, $goalid);
	}

	function is_goal_disabled_by_surveyid($surveyid){
		return $this->_check_goal_status(CMS_GOAL_STATUS_DISABLE, FALSE, $surveyid);
	}

	private function _check_goal_status($status, $goalid = FALSE, $surveyid = FALSE){
		$goal_status = FALSE;
		if ( $goalid ){
			$goal_status = $this->get_goal($goalid);
		}
		else if ( $surveyid ){
			$goal_status = $this->get_goalstatus_by_surveyid($surveyid);
		}
		if ( !is_object($goal_status) ){
			return FALSE;
		}
		if ( $goal_status->status == $status ){
			return TRUE;
		}
		return FALSE;
	}
}
?>