<?php
/**
 * admin_base.php - Base class for all menu templates
 *
 * @author $Author: dtong $
 * @version $Id: admin_base.php,v 1.7 2011/10/18 09:28:14 dtong Exp $
 * @copyright Copyright (c) 2011, Tiller Software Co., Ltd.
*/
if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class admin_menu_base {
	//All system menu items will start after 500 so site specific can start from 1
	//This can be change any time without any issues.
	static $index = 500;

	//Gets the menu items for system and application management
	static function get_system_array() {
		self::$index++;
		$result = array();
		$result[self::$index][0] = array('_menu_header'=> lang('admin_menu_title_basic'), '_menu_flag'  => TRUE);
		$result[self::$index][1] = array('_menu_title' => lang('admin_menu_config'), '_menu_image' => 'sysconfig.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/config/index/1',
							   '_menu_hr'    => FALSE);
		$result[self::$index][2] = array('_menu_title' => lang('admin_menu_dbupgrade'), '_menu_image' => 'db_upgrade.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/dbupgrade',
							   '_menu_hr'    => FALSE);
		$result[++self::$index][0] = array('_menu_header'=> FALSE, '_menu_flag'  => TRUE);
		$result[self::$index][1] = array('_menu_title' => lang('admin_menu_category'), '_menu_image' => 'category.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/category',
							   '_menu_hr'    => FALSE);
		$result[self::$index][2] = array('_menu_title' => lang('admin_menu_template_management'), '_menu_image' => 'template.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/config/index/2',
							   '_menu_hr'    => FALSE);
		$result[++self::$index][0] = array('_hr' => TRUE);
		$result[++self::$index][0] = array('_menu_header'=> lang('admin_menu_title_application'), '_menu_flag'  => TRUE);

		$result[self::$index][1] = array('_menu_title' => lang('admin_menu_user'), '_menu_image' => 'users.gif',
							 	'_menu_divid' => 'page_content', '_menu_url'   => 'admin/user',
		 					  	'_menu_hr'    => FALSE);

		$result[self::$index][2] = array('_menu_title' => lang('admin_menu_course'), '_menu_image' => 'course.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/course',
		 				      '_menu_hr'    => FALSE);
		$result[self::$index][3] = array('_menu_title' => lang('admin_menu_department'), '_menu_image' => 'departments.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/department',
							   '_menu_hr'    => FALSE);

		$result[++self::$index][0] = array('_menu_header'=> FALSE, '_menu_flag'  => TRUE);
		$result[self::$index][1] = array('_menu_title' => lang('admin_menu_grade'), '_menu_image' => 'grade.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/grade',
							   '_menu_hr'    => FALSE);
		$result[self::$index][2] = array('_menu_title' => lang('admin_menu_school'), '_menu_image' => 'school.gif',
						      '_menu_divid' => 'page_content', '_menu_url'   => 'admin/school',
								'_menu_hr'    => FALSE);
		$result[++self::$index][0] = array('_hr' => TRUE);
		return $result;
	}

	//Gets the strand, standard and benchmark menu items
	//$schoolbased is for LT based on schools, default is based on departments
	static function get_lt_array($lt_type=CMS_LEARNING_TARGETS_TYPE, $schoolbased=FALSE, $title=FALSE, $type_text=FALSE) {
		self::$index++;
		//Can't use self reference in a string so assign variable to address of class static variable
		$index = & self::$index;
		$result = array();

		if ( !$title ) {
			$title = lang('admin_menu_title_learning');
		}
		if ( !$type_text ) {
			$type_text = lang('admin_menu_type_lt_subtext');
		}
		//Learning Strand Management
		$result[self::$index][0] = array('_menu_header'=> $title, '_menu_flag'  => true);
		$result[self::$index][1] = array('_menu_title' => lang('admin_menu_strand'), '_menu_divid' => 'page_content',
							  '_menu_image' => 'strand.gif',
						     '_menu_url' => "admin/strand/index/$lt_type/{$index}/{$index}_2/{$index}_3",
							  '_menu_hr' => FALSE,'_title' => "$type_text - " . lang('admin_menu_strand_management') );
		//Learning Standard Management
		$result[self::$index][2] = array('_menu_title' => lang('admin_menu_standard'), '_menu_image' => 'standard.gif',
						     '_menu_divid' => 'page_content', '_menu_url' => "admin/standard/index/$lt_type/{$index}_2/{$index}_3",
		 					  '_menu_hr' => FALSE,'_title' => "$type_text - " . lang('admin_menu_standard_management') );
		//Learning Benchmark Management
		$result[self::$index][3] = array('_menu_title' => lang('admin_menu_benchmark'), '_menu_image' => 'benchmark.gif',
						     '_menu_divid' => 'page_content', '_menu_url' => "admin/benchmark/index/$lt_type/{$index}_3",
							  '_menu_hr' => FALSE,'_title' => "$type_text - " . lang('admin_menu_benchmark_management') );
		if ( $schoolbased ) {
			$result[self::$index][1]['_table'] = $result[self::$index][2]['_table'] = $result[self::$index][3]['_table'] = 'school_type';
			$result[self::$index][1]['_schoolflag'] = $result[self::$index][2]['_schoolflag'] = $result[self::$index][3]['_schoolflag'] = TRUE;
		}
		$result[++self::$index][0] = array('_hr' => TRUE);
		return $result;
	}

	//Gets the EQ menu item. This is for single EQ item per menu row.
	static function get_eq_array($eq_type=CMS_ESSENTIAL_QUESTION_TYPE) {
		self::$index++;
		$result = array();
		// Essential Questions
		$result[self::$index][0] = array('_menu_header'=> lang('admin_menu_title_eq'), '_menu_flag'  => TRUE );
		$result[self::$index][1] = self::get_eq(self::$index, $eq_type);
		$result[++self::$index][0] = array('_hr' => TRUE);
		return $result;
	}

	//Gets the EQ menu item
	static function get_eq($index, $eq_type=FALSE, $icon_title=FALSE) {
		if ( !$eq_type ) {
			$eq_type = CMS_ESSENTIAL_QUESTION_TYPE;
		}
		return self::get_select($index, $eq_type, lang('admin_select_eq_name'), lang('admin_select_eq_name_plural'),
					lang('admin_select_eq_shortname'), lang('admin_select_eq_shortname_plural'), FALSE, $icon_title);
	}

	//Config for select module related admin data like EQ
	//$fullname_plural not used yet but keep it to be consistent
	static function get_select($index, $type, $fullname, $fullname_plural=FALSE, $shortname=FALSE,
										$shortname_plural=FALSE, $image=FALSE, $icon_title=FALSE) {
		if ( !$fullname_plural ) {
			$fullname_plural = $fullname;
		}
		if ( !$shortname ) {
			$shortname = $fullname;
		}
		if ( !$shortname_plural ) {
			$shortname_plural = $fullname_plural;
		}
		if ( !$icon_title ) {
			$icon_title = $fullname;
		}
		if ( !$image ) {
			$image='strand.gif';
		}
		return
			array('_menu_title' => $icon_title, '_menu_image' => $image,
				  '_menu_divid' => 'page_content', '_menu_url' => "admin/eq/index/$type/$index",
				  '_menu_hr' => FALSE , '_list_title' => sprintf(lang('admin_select_menu_page_title'), $fullname),
				  '_add_head' => sprintf(lang('admin_select_menu_popup_add_window_title'), $shortname),
				  '_edit_head' => sprintf(lang('admin_select_menu_popup_edit_window_title'), $shortname),
				  '_add_title' => sprintf(lang('admin_select_menu_popup_add_title'), $fullname),
				  '_search_deparetmet' => lang('admin_select_menu_col_department'),
				  '_search' => sprintf(lang('admin_select_menu_col_search'), $shortname_plural),
				  '_tooltip_add' => sprintf(lang('admin_select_menu_tooltip_new_eq'), $shortname),
				  '_tooltip_edit' => sprintf(lang('admin_select_menu_tooltip_edit_eq'), $shortname),
				  '_tooltip_enable' => sprintf(lang('admin_select_menu_tooltip_enable_eq'), $shortname),
				  '_tooltip_disable' => sprintf(lang('admin_select_menu_tooltip_disable_eq'), $shortname),
	 			  '_filter' => array(sprintf(lang('admin_select_menu_filter_disabled_eqs'), $shortname_plural),
											sprintf(lang('admin_select_menu_filter_active_eqs'), $shortname_plural),
											lang('admin_select_menu_filter_showall')),
				  '_display_col' =>array(sprintf(lang('admin_select_menu_list_col_dept'), $fullname),
												 $fullname,
				  								 lang('admin_select_menu_list_col_enabled'),
				  								 lang('admin_select_menu_list_col_sort'), NULL),
				  '_input_col1' => lang('admin_select_menu_input_dept'),
				  '_input_col2' => $fullname,
				  '_input_col3' => lang('admin_select_menu_input_sortorder'),
				  '_input_col4' => lang('admin_select_menu_input_enabled'),
	 			  '_message_enable'=> sprintf(lang('admin_select_menu_message_confirm_enable'), $fullname),
				  '_message_disable'=> sprintf(lang('admin_select_menu_message_confirm_disable'), $fullname)
				);
	}

	static function get_appraiser_array($user_type=CMS_GOAL_APPRAISER_USER_TYPE,
													$group_role=CMS_USERROLE_GROUP_GOAL) {
		self::$index++;
		$result = array();
		//Appraisal user role management
		$result[self::$index][0] = array('_menu_header'=> lang('admin_menu_evaluation_management'), '_menu_flag'  => TRUE);
		$result[self::$index][1] = self::get_user_role(lang('menu_user_role_goal_appraisal'),
												$user_type, $group_role);
		$result[++self::$index][0] = array('_hr' => TRUE);
		return $result;
	}

	//Get a single user role menu item/icon
	static function get_user_role($title, $type, $group_role='null', $wintitle_override=FALSE, $schoolid='null', $departmentid='null') {
		$url = "admin/user_role/index/$type/$schoolid/$departmentid/$group_role";
		if ( $wintitle_override ) {
			$url .= '/' . rawurlencode($wintitle_override);
		}
		return array('_menu_title' => $title, '_menu_image' => 'user_role.gif',
						 '_menu_divid' => 'select_form', '_width'=>600, '_height'=>450, '_menu_hr' => FALSE,
						 '_win_title' => lang('user_role_win_header'), '_menu_new_win' => TRUE,
						 '_menu_url' => $url);
	}

}